<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout column align-center justify-center>
        <v-card width="90%">
            <v-card-title>
                <v-layout row class="fab-container">

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>

                </v-layout>
                <v-layout width="100%" align-start justify-center column>
                    <v-layout wrap min-width="100%">
                        <v-text-field @change="setFilterSearch" v-model="filter.search"
                                      label="جست و جو با نام یا شماره تماس یا کد ملی"></v-text-field>

                    </v-layout>
                    <v-layout align-start justify-center class="ma-2" row>
                        <v-btn
                                color="green"
                                dark
                                small
                                top
                                center
                                @click="readData"
                        >
                            اعمال فیلتر ها
                        </v-btn>

                        <v-btn
                                color="error"
                                dark
                                small
                                top
                                center
                                @click="removeFilter"
                        >
                            حذف فیلتر ها
                        </v-btn>
                    </v-layout>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-card class="mt-2" width="90%">
            <v-card-title>
                <v-layout column>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.first_name}}</td>
                            <td>{{ item.last_name}}</td>
                            <td>{{ item.national_code}}</td>
                            <td>{{ item.phone_number}}</td>
                            <td>{{ item.telephone_number}}</td>
                            <td>{{ item.postal_code}}</td>
                            <td>{{ item.email}}</td>
                            <td>{{ item.address}}</td>
                            <td>{{ item.credit}}</td>
                            <td>{{ item.city.name}}</td>
                            <td>{{ item.company_name}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                        small
                                        @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>
                            <td>
                                <v-btn small class="mr-2" color="error" @click="activateItem(item)">
                                    {{ item.status === 0 ? 'فعال سازی' : 'غیرفعال سازی'}}
                                </v-btn>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-form
                                ref="form"
                                v-model="valid"
                                lazy-validation
                        >
                            <v-layout wrap>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setFirstName" v-model="selectedItem.first_name"
                                                  label="نام"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setLastName" v-model="selectedItem.last_name"
                                                  label="نام خانوادگی"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setNationalCode" v-model="selectedItem.national_code"
                                                  label="کد ملی"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setCompanyName" v-model="selectedItem.company_name"
                                                  label="نام شرکت"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="phoneRules"
                                            type="number" @change="setPhoneNumber" v-model="selectedItem.phone_number"
                                            label="شماره تلفن"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field
                                            type="number" @change="setTelephoneNumber" v-model="selectedItem.telephone_number"
                                            label="شماره تلفن"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setEmail" v-model="selectedItem.email"
                                                  label="ایمیل"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setAddress" v-model="selectedItem.address"
                                                  label="آدرس"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-text-field
                                            type="number" @change="setPostalCode" v-model="selectedItem.postal_code"
                                            label="کد پستی"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" readonly v-model="selectedItem.city.name"
                                                  label="شهر"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-btn small class="mr-2" color="error" @click="showSelectCity">
                                        انتخاب شهر
                                    </v-btn>
                                </v-flex>


                            </v-layout>
                        </v-form>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این کاربر را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="WaitDialog"
                dark
                hide-overlay
                persistent
                width="300"
        >
            <v-card
                    color="primary"
                    dark
            >
                <v-card-text>
                    لطفا منتظر بمانید
                    <v-progress-linear
                            indeterminate
                            color="white"
                            class="mb-0"
                    ></v-progress-linear>
                </v-card-text>
            </v-card>
        </v-dialog>
        <v-dialog v-model="selectCity" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                            <v-flex xs12 sm6 md6>
                                <v-select
                                        v-model="selectedProvince"
                                        :items="province"
                                        item-text="name"
                                        outlined
                                        label="استان را انتخاب کنید"
                                        single-line
                                        @change="getCity"
                                        return-object
                                ></v-select>
                            </v-flex>

                            <v-flex xs12 sm6 md6>

                                <v-progress-circular v-show="this.cityPending === true" indeterminate
                                                     color="blue"></v-progress-circular>
                                <v-select
                                        v-show="this.cityPending === false"
                                        v-model="selectedCity"
                                        :items="city"
                                        item-text="name"
                                        outlined
                                        label="شهر را انتخاب کنید"
                                        single-line
                                        @change="setSelectedCity"
                                        return-object
                                ></v-select>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideSelectCity">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="saveSelectedItemCity">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="AlertDialog"
                max-width="500"
        >

            <v-card>
                <v-card-text>
                    {{alertDialogMessage}}
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAlertDialog">باشه</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "cargoOwner",
        methods: {
            ...mapMutations({
                setFirstName: 'cargoOwner/setFirstName',
                setLastName: 'cargoOwner/setLastName',
                setPostalCode: 'cargoOwner/setPostalCode',
                setAddress: 'cargoOwner/setAddress',
                setPhoneNumber: 'cargoOwner/setPhoneNumber',
                setTelephoneNumber: 'cargoOwner/setTelephoneNumber',
                setEmail: 'cargoOwner/setEmail',
                setNationalCode: 'cargoOwner/setNationalCode',
                setCompanyName: 'cargoOwner/setCompanyName',
                setSelectedItem: 'cargoOwner/setSelectedItem',
                showAddDialog: 'cargoOwner/showAddDialog',
                hideAddDialog: 'cargoOwner/hideAddDialog',
                showDeleteDialog: 'cargoOwner/showDeleteDialog',
                hideDeleteDialog: 'cargoOwner/hideDeleteDialog',
                showSelectCity: 'cargoOwner/showSelectCity',
                hideSelectCity: 'cargoOwner/hideSelectCity',
                showCityPending: 'cargoOwner/showCityPending',
                hideCityPending: 'cargoOwner/hideCityPending',
                setFilterSearch: 'cargoOwner/setFilterSearch',
                setProvince: 'cargoOwner/setProvince',
                setCity: 'cargoOwner/setCity',
                setSelectedProvince: 'cargoOwner/setSelectedProvince',
                setSelectedCity: 'cargoOwner/setSelectedCity',
                setSelectedItemCity: 'cargoOwner/setSelectedItemCity',
                hideAlertDialog:'cargoOwner/hideAlertDialog'
            }),
            ...mapActions({
                removeFilter: 'cargoOwner/removeFilter',
                readData: 'cargoOwner/readData',
                addOrEdit: 'cargoOwner/addOrEdit',
                deleteOne: 'cargoOwner/deleteOne',
                activate: 'cargoOwner/activate',
                getCityByProvince: 'cargoOwner/getCityByProvince'
            }),
            add() {
                this.setSelectedItem({
                    id: null,
                    freight_name: null,
                    owner_first_name: null,
                    owner_last_name: null,
                    username: null,
                    new_password: null,
                    owner_phone_number: null,
                    telephone_number: null,
                    status: null,
                    credit: null,
                    point: null,
                    marketer_id: null,
                    city_id: null,
                    city: {id: null, name: null}
                });
                this.showAddDialog();
            },
            edit(item) {

                console.log('item' , item);
                this.setSelectedItem({
                    id: item.id,
                    first_name: item.first_name,
                    last_name: item.last_name,
                    phone_number: item.phone_number,
                    status: item.status,
                    credit: item.credit,
                    address: item.address,
                    telephone_number: item.telephone_number,
                    company_name: item.company_name,
                    national_code: item.national_code,
                    latitude: item.latitude,
                    longitude: item.longitude,
                    postal_code: item.postal_code,
                    email: item.email,
                    marketer_id: item.marketer_id,
                    city_id: item.city_id,
                    city: item.city
                });
                this.showAddDialog();
                console.log('state' , this.selectedItem);
            },
            add_Edit() {
                if (this.$refs.form.validate()) {
                    this.addOrEdit();
                }
            },
            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
            activateItem(item) {
                this.setSelectedItem(item);
                this.activate(item)
            },
            getCity(item) {
                console.log('item', item);
                this.setSelectedProvince(item);
                this.getCityByProvince();
            },
            saveSelectedItemCity() {
                this.setSelectedItemCity();
                this.hideSelectCity()
            }
        },
        computed: {

            ...mapState({
                allData: state => state.cargoOwner.allData,
                AddDialog: state => state.cargoOwner.AddDialog,
                DeleteDialog: state => state.cargoOwner.DeleteDialog,
                selectedItem: state => state.cargoOwner.selectedItem,
                pending: state => state.cargoOwner.pending,
                allDataLoading: state => state.cargoOwner.allDataLoading,
                WaitDialog: state => state.cargoOwner.WaitDialog,
                selectCity: state => state.cargoOwner.selectCity,
                province: state => state.cargoOwner.province,
                city: state => state.cargoOwner.city,
                selectedProvince: state => state.cargoOwner.selectedProvince,
                selectedCity: state => state.cargoOwner.selectedCity,
                cityPending: state => state.cargoOwner.cityPending,
                filter: state => state.cargoOwner.filter,
                AlertDialog: state => state.cargoOwner.AlertDialog,
                alertDialogMessage: state => state.cargoOwner.alertDialogMessage,


            }),
            selectedProvince: {
                set: function (value) {

                },
                get: function () {

                }
            },
            selectedCity: {
                set: function (value) {

                },
                get: function () {

                }
            }
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                valid: true,
                nameRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                    v => (!v || v.length >= 2) || 'حداقل باید 4 کاراکتر بنویسید',
                ],
                numberRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                phoneRules: [
                    v => !!v || 'شماره موبایل لازم است',
                    v => (!v || v.length === 11) || 'شماره موبایل لازم است 11 رقم باشد',
                ],
                headers: [
                    {text: 'نام', align: 'right', value: 'first_name'},
                    {text: 'نام خانوادگی', align: 'right', value: 'last_name'},
                    {text: 'کد ملی', align: 'right', value: 'national_code'},
                    {text: 'شماره تلفن', align: 'right', value: 'phone_number'},
                    {text: 'شماره ثابت', align: 'right', value: 'telephone_number'},
                    {text: 'کد پستی', align: 'right', value: 'postal_code'},
                    {text: 'ایمیل', align: 'right', value: 'email'},
                    {text: 'آدرس', align: 'right', value: 'address'},
                    {text: 'اعتبار', align: 'right', value: 'credit'},
                    {text: 'شهر', align: 'right', value: 'city.name'},
                    {text: 'نام شرکت', align: 'right', value: 'company_name'},
                ],
            }
        },
    }
</script>
<style scoped>
    .layout{
        min-width: 100%;
    }
</style>
